﻿Imports System.IO

Public Class TabTest
    Public Sub New()

        ' La chiamata è richiesta dalla finestra di progettazione.
        InitializeComponent()

        cmbMode.SelectedIndex = 0

    End Sub

    Private Sub TestTab()

        Dim PDF417 As New PDF417
        Dim counter As Integer = 1
        Dim encodedText As String = ""
        Dim dataToEncode As String = "123456789012"
        Dim applyTilde As Boolean = False '' use ~ for special encoding
        Dim encodingMode As EncodingModes = EncodingModes.Binary
        Dim ecLevel As Integer = 0

        Dim PDFCols As Integer = 0
        Dim PDFRows As Integer = 0
        Dim truncate As Boolean = False


        Dim outType As OutputTypes = OutputTypes.IDA2DFont
        If (cmbMode.SelectedIndex = 1) Then outType = OutputTypes.IDAMonospaceFont
        Dim raster() As Byte
        Dim vector As String


        ''****************************************************************************************************************************************************
        dataToEncode = "IDAutomation.com 123456789012~m10"
        applyTilde = True
        ecLevel = 0
        encodingMode = EncodingModes.Text
        PDFCols = 4
        PDFRows = 0
        truncate = False


        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1



        ''****************************************************************************************************************************************************
        dataToEncode = "ID AutoMation.com~0091234567890123456(!@#$1234$^&*9999~`<>)"
        applyTilde = True
        ecLevel = 3
        encodingMode = EncodingModes.Binary
        PDFCols = 4
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1


        ''****************************************************************************************************************************************************
        dataToEncode = "ID AutoMation.com~0091234567890123456(!@#$1234$^&*9999~`<>)"
        applyTilde = True
        ecLevel = 3
        encodingMode = EncodingModes.Binary
        PDFCols = 4
        PDFRows = 0
        truncate = True

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1



        ''****************************************************************************************************************************************************
        dataToEncode = "Error Correction Level 1 Test [010491234512345IDAUTOMATION915970331301289999]"
        applyTilde = True
        ecLevel = 1
        encodingMode = EncodingModes.Text
        PDFCols = 3
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1



        ''****************************************************************************************************************************************************
        dataToEncode = "Error Correction Level 2 Test [010491234512345IDAUTOMATION915970331301289999]"
        applyTilde = True
        ecLevel = 2
        encodingMode = EncodingModes.Text
        PDFCols = 5
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1



        ''****************************************************************************************************************************************************
        dataToEncode = "Error Correction Level 3 Test [010491234512345IDAUTOMATION915970331301289999]"
        applyTilde = True
        ecLevel = 3
        encodingMode = EncodingModes.Text
        PDFCols = 6
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1



        ''****************************************************************************************************************************************************
        dataToEncode = "2D~~Matrix~ Tilde Test of popular codes: |~000|~001|~004|~009|~010|~013|~028|~029|~030|~031|~255| &lt;~END~d6u8~end&gt;"
        applyTilde = True
        ecLevel = 0
        encodingMode = EncodingModes.Binary
        PDFCols = 0
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1


        ''****************************************************************************************************************************************************
        dataToEncode = "256 Characters with Tilde Commands: (500 chrs total) |~000|~001|~002|~003|~004|~005|~006|~007|~008|~009|~010|~011|~012|~013|~014|~015|~016|~017|~018|~019|~020|~021|~022|~023|~024|~025|~026|~027|~028|~029|~030|~031|~032|~033|~034|~035|~036|~037|~038|~039|~040|~041|~042|~043|~044|~045|~046|~047|~048|~049|~050|~051|~052|~053|~054|~055|~056|~057|~058|~059|~060|~061|~062|~063|~064|~065|~066|~067|~068|~069|~070|~071|~072|~073|~074|~075|~076|~077|~078|~079|~080|~081|~082|~083|~084|~085|~086|~087|~088|~089|~090|~091|~092|~093|~094|~095|~096|~097|~098|~099|~100|~101|~102|~103|~104|~105|~106|~107|~108|~109|~110|~111|~112|~113|~114|~115|~116|~117|~118|~119|~120|~121|~122|~123|~124|~125|~126|~127|~128|~129|~130|~131|~132|~133|~134|~135|~136|~137|~138|~139|~140|~141|~142|~143|~144|~145|~146|~147|~148|~149|~150|~151|~152|~153|~154|~155|~156|~157|~158|~159|~160|~161|~162|~163|~164|~165|~166|~167|~168|~169|~170|~171|~172|~173|~174|~175|~176|~177|~178|~179|~180|~181|~182|~183|~184|~185|~186|~187|~188|~189|~190|~191|~192|~193|~194|~195|~196|~197|~198|~199|~200|~201|~202|~203|~204|~205|~206|~207|~208|~209|~210|~211|~212|~213|~214|~215|~216|~217|~218|~219|~220|~221|~222|~223|~224|~225|~226|~227|~228|~229|~230|~231|~232|~233|~234|~235|~236|~237|~238|~239|~240|~241|~242|~243|~244|~245|~246|~247|~248|~249|~250|~251|~252|~253|~254|~255"
        applyTilde = True
        ecLevel = 0
        encodingMode = EncodingModes.Binary
        PDFCols = 10
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1


        ''****************************************************************************************************************************************************
        dataToEncode = "[3000CHRS::THE FOLLOWING IS A 2-D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 123456789883000CHRS-THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A2DScanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 12345678988**]"
        applyTilde = True
        ecLevel = 0
        encodingMode = EncodingModes.Binary
        PDFCols = 0
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1


        ''****************************************************************************************************************************************************
        dataToEncode = "[3000CHRS::THE FOLLOWING IS A 2-D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 123456789883000CHRS-THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The Following Is A2DScanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING]1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING SPACES. The FollowingIs A 2D Scanner Test Of Characters Including Spaces. 1234567890123456789012 THE FOLLOWING IS A 2D SCANNER TEST OF CHARACTERS INCLUDING THE FOLLOWING IS A 2DSCANNER TEST OF CHARACTERS INCLUDING1234567890123456789012 12345678988**]"
        applyTilde = True
        ecLevel = 0
        encodingMode = EncodingModes.Text
        PDFCols = 0
        PDFRows = 0
        truncate = False

        If (cmbMode.SelectedIndex = 2) Then '' BMP Then raster image output
            raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, 2, 3)
        ElseIf (cmbMode.SelectedIndex = 3) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecSVG, "", 2, 2)
        ElseIf (cmbMode.SelectedIndex = 4) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, VectorTypes.VecHTML, "", 2, 1)
        Else
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, truncate, outType)
        End If
        renderBarcodeToTab("PDF417_" + counter.ToString(), dataToEncode, encodingMode.ToString(), encodedText, raster, vector)

        If (chkSaveEPS.Checked) Then
            vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ecLevel, encodingMode, PDFCols, PDFRows, VectorTypes.VecEPS, "", 2, 2)
            File.WriteAllText("PDF417" + counter.ToString() + ".EPS", vector)
        End If
        counter += 1

    End Sub


    Private Sub renderBarcodeToTab(tabName As String, dataToEncode As String, encodingMode As String, encodedText As String, raster As Byte(), vector As String)

        Dim LL As Integer = 20
        Dim LTOP As Integer = 10
        Dim YSpacing As Integer = 10


        Dim tp As New TabPage(tabName)
        tp.Font = New System.Drawing.Font("Consolas", 10.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
        tp.AutoScroll = True ''allow scrolling to fit output
        TabControl1.TabPages.Add(tp) ''add tab to page

        '' TOP - LEFT
        Dim showDTEText As New Label
        showDTEText.Name = "showDTEText"
        showDTEText.Location = New System.Drawing.Point(LL, LTOP)
        showDTEText.AutoSize = True
        showDTEText.Text = "DATA ENCODED: "
        showDTEText.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
        tp.Controls.Add(showDTEText)

        Dim showDTE As New Label
        showDTE.Name = "showDTE"
        showDTE.Location = New System.Drawing.Point(LL, showDTEText.Location.Y + showDTEText.Height + YSpacing)
        showDTE.AutoSize = True
        showDTE.Text = formatText(dataToEncode)
        tp.Controls.Add(showDTE)


        '' encodingMode
        Dim lblEncMode As New Label
        lblEncMode.Location = New System.Drawing.Point(LL, showDTE.Location.Y + showDTE.Height + YSpacing)
        lblEncMode.Name = "lblECM"
        lblEncMode.Size = New System.Drawing.Size(200, 13)
        lblEncMode.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
        lblEncMode.Text = "ENC MODE: " + encodingMode.ToUpper()
        tp.Controls.Add(lblEncMode)

        ''barcode
        Dim lblBarcodeTitle As New Label
        lblBarcodeTitle.AutoSize = True
        lblBarcodeTitle.Location = New System.Drawing.Point(LL, lblEncMode.Location.Y + lblEncMode.Height + YSpacing)
        lblBarcodeTitle.Name = "lblDTETitle"
        ''lblBarcodeTitle.Size = New System.Drawing.Size(83, 13)
        lblBarcodeTitle.Text = "BARCODE:"
        lblBarcodeTitle.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
        tp.Controls.Add(lblBarcodeTitle)

        Dim lblBarcode As New Label
        lblBarcode.AutoSize = True
        lblBarcode.Location = New System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing)
        lblBarcode.Name = "lblBarcodeBox"
        lblBarcode.Text = encodedText

        If (cmbMode.SelectedIndex = 1) Then
            lblBarcode.Font = New System.Drawing.Font("Courier New", 6.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
            tp.Controls.Add(lblBarcode)
        ElseIf (cmbMode.SelectedIndex = 0) Then
            lblBarcode.Font = New System.Drawing.Font("IDAutomation2D", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
            tp.Controls.Add(lblBarcode)

            ''encoded data
            Dim lblEncDataTitle As New Label
            lblEncDataTitle.AutoSize = True
            lblEncDataTitle.Location = New System.Drawing.Point(LL, lblBarcode.Location.Y + lblBarcode.Height + YSpacing)
            lblEncDataTitle.Name = "lblDTETitle"
            ''lblEncDataTitle.Size = New System.Drawing.Size(83, 13)
            lblEncDataTitle.Text = "ENCODED RESULT:"
            lblEncDataTitle.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
            tp.Controls.Add(lblEncDataTitle)

            Dim lblEncData = New Label
            lblEncData.Location = New System.Drawing.Point(LL, lblEncDataTitle.Location.Y + lblEncDataTitle.Height + YSpacing)
            lblEncData.Name = "lblEncData"
            lblEncData.AutoSize = True
            lblEncData.Text = encodedText
            tp.Controls.Add(lblEncData)

        ElseIf (cmbMode.SelectedIndex = 2) Then
            Dim picImage As PictureBox = New PictureBox()
            picImage.AutoSize = True
            picImage.Location = New System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing)
            picImage.Name = "picDM"
            Dim mStream As MemoryStream = New MemoryStream(raster)
            Dim img1 As Image = Image.FromStream(mStream)
            picImage.Image = img1
            tp.Controls.Add(picImage)

        ElseIf (cmbMode.SelectedIndex = 3 Or cmbMode.SelectedIndex = 4) Then
            Dim WebBrowser As WebBrowser = New WebBrowser()
            WebBrowser.Location = New System.Drawing.Point(LL, lblBarcodeTitle.Location.Y + lblBarcodeTitle.Height + YSpacing)
            WebBrowser.Width = tp.Width - WebBrowser.Left
            WebBrowser.Height = tp.Height - WebBrowser.Top
            WebBrowser.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Bottom
            WebBrowser.DocumentText = vector
            tp.Controls.Add(WebBrowser)

        End If




    End Sub


    Private Function formatText(inText As String) As String
        Dim maxWidth As Integer = 175 '' width Of text shown In window
        Dim formattedString As String = ""

        For i = 0 To inText.Length - 1 Step maxWidth
            formattedString += SafeSubstring(inText, i, maxWidth) + Environment.NewLine
        Next

        formatText = formattedString
    End Function

    Private Function SafeSubstring(value As String, startIndex As Integer, length As Integer) As String
        If (value <> "") Then
            If (value.Length - startIndex) < length Then length = value.Length - startIndex
            value = value.Substring(startIndex, length)
        End If
        SafeSubstring = value
    End Function

    Private Sub chkSaveEPS_CheckedChanged(sender As Object, e As EventArgs) Handles chkSaveEPS.CheckedChanged
        TabControl1.TabPages.Clear()
        TestTab()
    End Sub

    Private Sub cmbMode_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbMode.SelectedIndexChanged
        TabControl1.TabPages.Clear()
        TestTab()
    End Sub
End Class
