﻿Imports System.IO

Public Class FullTest
    Public Sub New()

        InitializeComponent()

        cmbOutput.SelectedIndex = 1
        cbEncoding.SelectedIndex = 0
        cbECCLevel.SelectedIndex = 0
        txtModuleSize.Text = "2"
        txtQuietZone.Text = "2"
        txtRows.Text = "0"
        txtCols.Text = "0"


    End Sub

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        TabTest.ShowDialog()
    End Sub

    Private Sub btnApply_Click(sender As Object, e As EventArgs) Handles btnApply.Click

        Dim dataToEncode As String = tbDatatoencode.Text
        Dim applyTilde As Boolean = ckApplyTilde.Checked
        Dim truncate As Boolean = ckTruncate.Checked
        Dim ModuleSize As Integer = CInt(txtModuleSize.Text)
        Dim QuietZone As Integer = CInt(txtQuietZone.Text)
        Dim TotalRows As Integer = CInt(txtRows.Text)
        Dim TotalCols As Integer = CInt(txtCols.Text)
        Dim ECLevel As Integer = cbECCLevel.SelectedIndex


        If (TotalRows > 89) Then
            TotalRows = 89
            txtRows.Text = "89"
        End If

        If (TotalCols > 30) Then
            TotalCols = 30
            txtCols.Text = "30"
        End If

        Dim encodingMode As EncodingModes = EncodingModes.Binary
        Select Case cbEncoding.SelectedIndex
            Case 1
                encodingMode = EncodingModes.Text

        End Select


        Dim PDF417 As New PDF417()
        Dim raster() As Byte
        Dim vector As String = ""
        Dim encodedText As String = ""

        Dim outType As OutputTypes = OutputTypes.IDA2DFont
        If (cmbOutput.SelectedIndex = 2) Then outType = OutputTypes.IDAMonospaceFont

        webCode.Visible = False
        picCode.Visible = False
        lblCode.Visible = False

        If (cmbOutput.SelectedIndex <= 2) Then
            encodedText = PDF417.EncodePDF417(dataToEncode, applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate, outType)
            If (cmbOutput.SelectedIndex = 2) Then
                lblCode.Font = New System.Drawing.Font("Courier New", 6.0F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
            ElseIf (cmbOutput.SelectedIndex = 1) Then
                lblCode.Font = New System.Drawing.Font("IDAutomation2D", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, 0)
            ElseIf (cmbOutput.SelectedIndex = 0) Then
                lblCode.Font = New System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 0)
            End If
            lblCode.Text = encodedText
            lblCode.Visible = True

        Else
            If (cmbOutput.SelectedIndex = 3) Then '' BMP raster image output

                raster = PDF417.EncodePDF417(dataToEncode, applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate, QuietZone, ModuleSize)
                picCode.AutoSize = True

                Dim mStream As MemoryStream = New MemoryStream(raster)
                Dim img1 As Image = Image.FromStream(mStream)
                picCode.Image = img1

                '' code to produce a PNG Or a GIF Or other formats
                '' **************************************************
                ''MemoryStream mStream1 = New MemoryStream(raster);
                ''Image img1 = Image.FromStream(mStream1);

                ''MemoryStream mStream2 = New MemoryStream();
                ''/if ( __PNG__ ) // PNG
                ''    img1.Save(mStream2, ImageFormat.Png);
                ''else if ( __GIF__ ) // GIF
                ''    img1.Save(mStream2, ImageFormat.Gif);

                ''raster = mStream2.ToArray();
                ''**************************************************
                picCode.Visible = True
                If (chkSaveGraphic.Checked) Then File.WriteAllBytes("PDF417.BMP", raster)

            ElseIf (cmbOutput.SelectedIndex = 4) Then
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate, VectorTypes.VecSVG, "", QuietZone, ModuleSize)
                webCode.DocumentText = vector
                webCode.Visible = True
                If (chkSaveGraphic.Checked) Then File.WriteAllText("PDF417.SVG", vector)

            ElseIf (cmbOutput.SelectedIndex = 5) Then
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate, VectorTypes.VecHTML, "", QuietZone, ModuleSize)
                webCode.DocumentText = vector
                webCode.Visible = True
                If (chkSaveGraphic.Checked) Then File.WriteAllText("PDF417.HTML", vector)

            ElseIf (cmbOutput.SelectedIndex = 6) Then
                vector = PDF417.EncodePDF417(dataToEncode, applyTilde, ECLevel, encodingMode, TotalCols, TotalRows, truncate, VectorTypes.VecEPS, "", QuietZone, ModuleSize)
                If (chkSaveGraphic.Checked) Then File.WriteAllText("PDF417.EPS", vector)

            End If
        End If

    End Sub

    Private Sub cmbOutput_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cmbOutput.SelectedIndexChanged
        txtQuietZone.Enabled = (cmbOutput.SelectedIndex >= 3)
        txtModuleSize.Enabled = (cmbOutput.SelectedIndex >= 3)
        chkSaveGraphic.Enabled = (cmbOutput.SelectedIndex >= 3)
    End Sub
End Class